--- /home/khaled/vc/luatex/src/texk/web2c/luatexdir/luatex.web	2008-12-31 03:37:23.000000000 +0200
+++ luatex.web	2009-01-07 04:13:58.000000000 +0200
@@ -30633,7 +30633,15 @@
 
 @ @<Output a Image node in a vlist@>=
 begin cur_v:=cur_v+pdf_height(p)+pdf_depth(p);
-  cur_h:=left_edge;
+  case font_direction(dvi_direction) of
+  dir__LT,dir__LB: begin
+    cur_h:=left_edge;
+    end;
+  dir__RT,dir__RB: begin
+    cur_h:=cur_h-pdf_width(p);
+    end;
+  othercases cur_h:=left_edge;
+  endcases;
   output_image(pdf_ximage_idx(p));
 end
 
@@ -30694,8 +30702,18 @@
 @ @<Output a Image node in a hlist@>=
 begin
   cur_v:=base_line+pdf_depth(p);
+  case font_direction(dvi_direction) of
+  dir__LT,dir__LB: begin
+    edge:=cur_h+pdf_width(p);
+    end;
+  dir__RT,dir__RB: begin
+    cur_h:=cur_h-pdf_width(p);
+    edge:=cur_h;
+    end;
+  othercases edge:=cur_h+pdf_width(p);
+  endcases;
   output_image(pdf_ximage_idx(p));
-  edge:=cur_h+pdf_width(p); cur_h:=edge; cur_v:=base_line;
+  cur_h:=edge; cur_v:=base_line;
 end
 
 @ @<Output a Form node in a hlist@>=
